<?php

if(is_admin()){
    include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
}

class WC_MC_Gabon  extends WC_Payment_Gateway
{
    //private $mc_page_title = "Moov Money Redirection";
    private $mc_page_title = "Paiement moov money en cours";
    
    private $pvitEndPoint = "https://mypvitapi.pro/api/pvit-secure-full-api-v3.kk";
    public function __construct() {

        // called after all plugins have loaded
        $this->init_form_fields();
        $this->templates =  wp_get_theme()->get_page_templates();
        if ( empty( $this->templates ) ) {
            $this->templates = array();
        }
    
        $this->order_button_text='Payer';
        $this->id = "wc_mc_gabon";
        $this->icon = plugins_url()."/woocommerce-moovmoney-gabon/images/moov.png";
        $this->has_fields = true;
        $this->method_title = __("Moov Money Gabon", 'wc_moovmoney_gabon');
        $this->method_description = __("Moov Money Gabon payment gateway for woocommerce", 'wc_moovmoney_gabon');
        $this->view_transaction_url = 'https://mypvitapi.pro/api/pvit-secure-full-api-v3.kk';
        $this->title = __("Moov Money Gabon", 'wc_moovmoney_gabon');
        $this->redirect_page_id = '';
        $this->liveurl = "https://mypvitapi.pro/api/pvit-secure-full-api-v3.kk";
    
           
        add_filter('wc-mc-get-telmarchand','get_telmarchand');
         if ( is_admin() ) {

            // Versions over 2.0
            // Save our administration options. Since we are not going to be doing anything special
            // we have not defined 'process_admin_options' in this class so the method in the parent
            // class will be used instead
            add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
        }
        $this->init_settings();
        // Turn these settings into variables we can use
        foreach ( $this->settings as $setting_key => $value ) {
            $this->$setting_key = $value;
        }
        
        add_action( 'woocommerce_api_'.$this->id, array( $this , 'run_pvit_callback' ) );


        // Add a filter to the attributes metabox to inject template into the cache.
        if ( version_compare( floatval( get_bloginfo( 'version' ) ), '4.7', '<' ) ) {

            // 4.6 and older
            add_filter(
                'page_attributes_dropdown_pages_args',
                array( $this, 'register_project_templates' )
            );

        } else {

            // Add a filter to the wp 4.7 version attributes metabox
            add_filter(
                'theme_page_templates', array( $this, 'add_new_template' )
            );

        }

        // Add a filter to the save post to inject out template into the page cache
        add_filter(
            'wp_insert_post_data', 
            array( $this, 'register_project_templates' ) 
        );

        // Add a filter to the template include to determine if the page has our 
        // template assigned and return it's path
        add_filter(
            'template_include', 
            array( $this, 'view_project_template') 
        );

        // Add your templates to this array.
        $this->templates = array(
            'Moov.php' => 'Moov',
        );

    }


    /**
     * Init setting form fields
     *
     */
    public function get_telmarchand(){
        return $this->settings["tel_marchand"];

    }

    public function init_form_fields()
     {
        $this->form_fields = apply_filters( 'wc_offline_form_fields', array(
          
            'enabled' => array(
                'title'   => 'Activer/Desactiver',
                'type'    => 'checkbox',
                'label'   => 'Activer le paiement par Moov Money',
                'default' => 'yes'
            ),
    
            'title' => array(
                'title'       =>  'Titre',
                'type'        => 'text',
                'description' => 'Ce champ control le titre appercu par le client pendant le paiement.',
                'default'     => get_option("title"),
                'desc_tip'    => true,
            ),
    
            'description' => array(
                'title'       => 'Description',
                'type'        => 'textarea',
                'description' => 'Paiement en ligne via Moov Money.',
                'default'     => __('Payer facilement en ligne via Moov Money.','wc-moovmoney-gabon'),
                'desc_tip'    => true,
            ),
    
            'tel_marchand' => array(
                'title'       => 'Numero de telephone marchand',
                'type'        => 'text',
                'description' => 'Numero Moov utilise pour creer le compte marchand',
                'default'     => '',
                'desc_tip'    => true,
            ),

            'token' => array(
                'title'       => 'Clé de sécurité',
                'type'        => 'text',
                'description' => 'Token de sécurité',
                'default'     => '',
                'desc_tip'    => true,
            ),

            'phone_preffix' => array(
                'title'       => 'Préffixe',
                'type'        => 'text',
                'description' => 'Préffixe de numéro MOOV',
                'default'     => '06',
                'desc_tip'    => true,
            ),

            'phone_length' => array(
                'title'       => 'Nombre de caractère de num Moov',
                'type'        => 'text',
                'description' => 'Nombre de caractère de num Moov',
                'default'     => '9',
                'desc_tip'    => true,
            ),
    
            'url_redirect' => array(
                'title'       => 'Url de redirection',
                'type'        => 'text',
                'description' => 'Url vers laquelle le client est redirigé ',
                'default'     => '',
                'desc_tip'    => true
            ),
            'loader' => array(
                'title'       => "Message d'attente ",
                'type'        => 'text',
                'description' => "message d'attente ",
                'default'     => '',
                'desc_tip'    => true
            )
        ) );
     }


     public function init_settings()
     {
         parent::init_settings(); // TODO: Change the autogenerated stub
     }


    public function process_payment( $order_id )
    {
       $order = wc_get_order($order_id);

        if (!$this->checkSettingsForTrx($order->get_total())) {
            wc_add_notice( __('Moov money error : ', 'woothemes') . 'Montant inssufissant ou paramétres du plugin incorrects', 'error' );
            return false;
        }


     // Mark as on-hold (we're awaiting the payment)
        $order->update_status('on-hold', __('Start payment', 'wc-gateway-offline'));
        $order->update_meta_data( 'telclient', $this->get_field_value('telclient','telclient') );
        $order->update_meta_data( 'reference', $order->get_id() );
        // Save order
        $order->save();
        $order = wc_get_order($order_id);
        // $order->reduce_order_stock();
        wc_reduce_stock_levels($order_id);
        $body = [
                "ref"=>$order->get_id(),
                "montant"=>$order->get_total(),
                "tel_marchand"=>$this->get_telmarchand(),
                "tel_client"=> $this->get_field_value('telclient','telclient'),
                "service"=>"REST",
                "operateur"=>"MC",
                "token"=>$this->settings["token"]
            ];
        
        $response = wp_remote_post( $this->pvitEndPoint, array(
            "timeout"     => 60,
            "headers" => ["Content-Type" => "application/x-www-form-urlencoded","Accept" => "text/xml"],
            "body"    => http_build_query($body)
        ) );
        print_r($response);
          try {
            $parseData = new SimpleXMLElement($response["body"]);
            $ligneData = $parseData[0];
            if ($ligneData->STATUT && ($ligneData->STATUT == 200 || $ligneData->STATUT == "200")) {
                $order->update_status('pending', __('Waiting for payment', 'wc-gateway-offline'));
                $order->add_order_note(__('Moov Money Waiting for customer confirmation.', 'wc-moovmoney-gabon'));
                return array(
                    'result' => 'success',
                    'redirect' => $this->get_return_url( $order )
                );
            } else{
               // $order->cancel_order();
                $order->update_status('failed', __('Payment failed', 'wc-gateway-offline'));
                $error_message = $ligneData->MESSAGE;
                wc_add_notice( __('Payment error:', 'woothemes') . $error_message, 'error' );
                $order->add_order_note(__('Moov Money payment failed.', 'wc-moovmoney-gabon'));
                return array();
            }
            echo($response["body"]);
            exit();
          } catch (\Throwable $th) {
            wc_add_notice( __('Moov money error : ', 'woothemes') . "Une erreur inattendue s'est produite. veuillez réessayer svp", 'error' );
            return false;
          }
            
           
       

    }



    public function run_pvit_callback() {
        $data_received=file_get_contents("php://input");
        $data_received_xml=new SimpleXMLElement($data_received);
        $ligne_response=$data_received_xml[0];
        $reference_received=$ligne_response->REF; // Rér&rence de la transaction == ID de la commande
        $numTransaction=isset($ligne_response->NUM_TRANSACTION) ? $ligne_response->NUM_TRANSACTION.'' : ''; // Numero transaction == ID de la transaction
        $statut_received=$ligne_response->STATUT; // Statut final de la transaction
        $token = $ligne_response->TOKEN.'';
        $order = wc_get_order(intval($reference_received));
        $order->update_meta_data( 'numTransaction', $numTransaction.'' );
       
        $order->save();
        if ( $order && $order->get_status() == 'pending') {
            if ( 200 == $statut_received) {
                echo ('200:Success - ');
                $order->payment_complete();
            } else {
                print_r('400:Failed');
                $order->update_status('failed', __('Payment failed', 'wc-gateway-offline'));
                wc_add_notice( __('Payment error:', 'woothemes') . $error_message, 'error' );
                $order->add_order_note(__('Moov Money payment failed.', 'wc-moovmoney-gabon'));
                return;
            }
            $this->update_option("token",$token);
        } else {
            print_r('404:Order not found');
        }
        exit();
    }



    public function add_new_template( $posts_templates ) {
        $posts_templates = array_merge( $posts_templates, $this->templates );
        return $posts_templates;
    }

    /**
     * Adds our template to the pages cache in order to trick WordPress
     * into thinking the template file exists where it doens't really exist.
     */
    public function register_project_templates( $atts ) {
        // Create the key used for the themes cache
        $cache_key = 'page_templates-' . md5( get_theme_root() . '/' . get_stylesheet() );

        // Retrieve the cache list.
        // If it doesn't exist, or it's empty prepare an array
        $templates = wp_get_theme()->get_page_templates();
        if ( empty( $templates ) ) {
            $templates = array();
        }

        // New cache, therefore remove the old one
        wp_cache_delete( $cache_key , 'themes');

        // Now add our template to the list of templates by merging our templates
        // with the existing templates array from the cache.
        $templates = array_merge( $templates, $this->templates );

        // Add the modified cache to allow WordPress to pick it up for listing
        // available templates
        wp_cache_add( $cache_key, $templates, 'themes', 1800 );
        return $atts;
    }

    /**
     * Checks if the template is assigned to the page
     */
    public function view_project_template( $template ) {
        // Return the search template if we're searching (instead of the template for the first result)
        if ( is_search() ) {
            return $template;
        }

        // Get global post
        global $post;
        // Return template if post is empty
        if ( ! $post ) {
            return $template;
        }

        // Return default template if we don't have a custom one defined
        if ( ! isset( $this->templates[get_post_meta(
            $post->ID, '_wp_page_template', true
        )] ) ) {
            return $template;
        }

        // Allows filtering of file path
        $filepath = apply_filters( 'page_templater_plugin_dir_path', plugin_dir_path( __FILE__ ) );
        $file =  $filepath . get_post_meta(
            $post->ID, '_wp_page_template', true
        );

        // Just to be safe, we check if the file exist first
        if ( file_exists( $file ) ) {
            return $file;
        } else {
            echo $file;
        }

        // Return template
        return $template;
    }

    public function payment_fields(){
        echo $this->generate_text_html('telclient',
            array(
                    'title'       =>  'Numero Moov Money',
                    'type'        => 'text',
                    'placeholder' => 'Numero moov money',
                    'description' => 'Votre numero moov money.',
                    'default'     => get_option("Numero Moov"),
                    'desc_tip'    => true,
                    'custom_attributes' => array(
                        'onkeydown'=>'jQuery(\'#woocommerce_wc_mc_gabon_telclient\').val(jQuery(\'#woocommerce_wc_mc_gabon_telclient\').val().replace(/\D/g, \'\'))',
                        'onkeyup'=>'jQuery(\'#woocommerce_wc_mc_gabon_telclient\').val(jQuery(\'#woocommerce_wc_mc_gabon_telclient\').val().replace(/\D/g, \'\'))'
                    )
            )
        );

            //txb.value.replace(/[^\0-9]/ig, "")
    }

    public function validate_fields(){
        $telclient = $this->get_field_value('telclient','telclient');
        if ( $telclient ){ 
            $telclient = trim(str_replace(' ','',$telclient));
            //if(preg_match("/^".$this->settings["phone_preffix"]."[0-9]{".$this->settings["phone_length"]."}/i",$telclient)) {
            $maxlength = intval($this->settings["phone_length"]-strlen($this->settings["phone_preffix"]));
            if(preg_match("/^".$this->settings["phone_preffix"]."[0-9]{".$maxlength."}$/i",$telclient)) {
                return true;
            }
        } 
        wc_add_notice( '<strong>'.__('Moov money ', 'woothemes') . "</strong>Veuillez saisir un numero correct", 'error' );
        return false;
    }

    public function checkSettingsForTrx($montant){
        $isTokenOK = (!is_null($this->settings['token'])) && (strlen($this->settings['token']) > 20) && (explode('.',$this->settings['token']) > 3);
        $isTelmarchandOk = !is_null($this->settings['tel_marchand']);
        $isMontantOK = ($montant > 101);
        return $isMontantOK && $isTokenOK && $isTelmarchandOk;
    }

    public function chechPvitStatus($orderId){
        $order = wc_get_order($orderId);
        $body = [
            "ref"=>$order->get_id(),
            "tel_marchand"=>$this->get_telmarchand(),
            "operateur"=>"MC",
            "service"=>"REST",
            "action"=>3,
            "token"=>$this->settings["token"]
        ];
    
        $response = wp_remote_post( $this->pvitEndPoint, array(
            "timeout"     => 60,
            "headers" => ["Content-Type" => "application/x-www-form-urlencoded","Accept" => "text/xml"],
            "body"    => http_build_query($body)
        ) );


            try {
                $parseData = new SimpleXMLElement($response["body"]);
        $ligneData = $parseData[0];
        $statut = $ligneData->STATUT.'';
        $num_transaction=$ligneData->NUM_TRANSACTION.'';
        $num_operateur=$ligneData->NUM_OPERATEUR.'';
        // NUM_OPERATEUR
        if ($statut && ($statut == 200 || $statut == "200")) {
            $order->update_status('processing', __('Payment completed', 'wc-gateway-offline'));
            $order->add_order_note(__('Moov Money payment successful.', 'wc-moovmoney-gabon'));
            $order->update_meta_data( 'numTransaction',$num_transaction);
            $order->update_meta_data( 'numOperateur',$num_operateur);
            // Save order
            $order->save();
            return 'processing';
        } elseif(is_numeric($statut)){
            // if($ligneData->STATUT) {
                $order->update_status('failed', __('Payment failed', 'wc-gateway-offline'));
                $order->add_order_note(__('Moov Money payment failed.', 'wc-moovmoney-gabon'));
                $order->update_meta_data( 'numTransaction',$num_transaction);
                $order->update_meta_data( 'numOperateur',$num_operateur);
                // Save order
                $order->save();
                return 'failed';
            // }
        }else {
         
        }
            } catch (\Throwable $th) {
                wc_add_notice( __('Moov money error : ', 'woothemes') . "Une erreur inattendue s'est produite. veuillez réessayer svp", 'error' );
                return false;
            }





       
    }


}

// finally instantiate our plugin class and add it to the set of globals

$GLOBALS['wc_mc_gabon'] = new WC_MC_Gabon();
