<?php
/*
Plugin Name: Moovmoney - WooCommerce
Description: Extends WooCommerce by Adding the Pvit-Moov money gateway
Version: 1
Author: Bako Ai
*/
    //if(is_admin()){
        include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
        include_once( ABSPATH . 'wp-includes/plugin.php' );
       
    //}
    //check if WC plugin is active
    if ( ! in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) return;


    // Include our Gateway Class and Register Payment Gateway with WooCommerce
    add_action( 'plugins_loaded', 'moovmoney_gabon_init', 0 );
    function moovmoney_gabon_init() {

        if ( ! class_exists( 'WC_Payment_Gateway' ) ) return;
        // If we made it this far, then include our Gateway Class
        include_once('moovmoney-gabon.php');
        add_filter( 'woocommerce_payment_gateways', 'add_moovmoney_gabon' );
        function add_moovmoney_gabon( $methods ) {
            $methods[] = 'wc_mc_gabon';
            return $methods;
        }

    }

    add_action( 'woocommerce_init', 'moovmoney_gabon_add_redirect_page', 1 );
    function moovmoney_gabon_add_redirect_page() {
        if (!function_exists("the_slug_exists")) 
        {
                function the_slug_exists($plugin_post_name)
                {
                    global $wpdb;
                    if($wpdb->get_row("SELECT post_name FROM ".$wpdb->prefix."posts WHERE post_name LIKE '" . $plugin_post_name . "'", 'ARRAY_A'))
                        {
                        return true;
                            } else {
                                return false;
                    }
                }
        } 
    
        // Create redirection page
        $page_slg_string = "mc-gabon-plugin-redirection-page-wait";
        $tplt_name = "Moov.php";
       
        if(!the_slug_exists($page_slg_string) ){
            //
            $blog_page_title = 'Moov Money Redirection';
            $blog_page_title = 'Paiement moov money en cours';
            $blog_page = array(
                'post_type' => 'page',
                'post_title' => $blog_page_title,
                'post_content' => '',
                'post_parent' => '',
                'post_status' => 'publish',
                'post_author' => 1,
                'post_name' => 'mc-gabon-plugin-redirection-page-wait',
                'page_template' => $tplt_name
            );

            $page_id = wp_insert_post($blog_page);
            update_post_meta( $page_id, '_wp_page_template', $tplt_name  );
            return $page_id;
        }
    }


    function wc_add_custom_fields_to_order( $order ) {

        $order->update_meta_data( 'telclient', ''); 
        $order->update_meta_data( 'numTransaction', ''); 
        $order->update_meta_data( 'reference', ''); 
    }
    add_action( 'woocommerce_checkout_create_order', 'wc_add_custom_fields_to_order', 10, 1 );


    // Add custom action links
    add_filter( 'plugin_action_links_' . plugin_basename( __FILE__ ), 'wc_moovmoney_gabon_action_links' );
    function wc_moovmoney_gabon_action_links( $links ) {
        $plugin_links = array(
            '<a href="' . admin_url( 'admin.php?page=wc-settings&tab=checkout' ) . '">' . __( 'Settings', 'wc-moovmoney-gabon' ) . '</a>',
        );
        // Merge our new link with the default ones
        return array_merge( $plugin_links, $links );
    }

    /**
     * Custumize thank you page and wait for payment confirmation
    */
    add_action('woocommerce_before_thankyou', 'wait_for_confirmation_onthankyoupage');
    function wait_for_confirmation_onthankyoupage($order) {
        //global 
        $orderData = new WC_Order( $order );
        if ( ($orderData->get_payment_method().' == '.$GLOBALS['wc_mc_gabon']->id) && (in_array($orderData->get_status(),['pending'])) ){
            //if($orderData->get_payment_method())
            $l = plugin_dir_url(__FILE__)."images/moov1.png";
            $g = plugin_dir_url(__FILE__)."mc_plugin/loader.gif";
            $loaderWhite = plugin_dir_url(__FILE__)."images/loader-white.gif";
            $tel = $orderData->get_meta( 'telclient');
            $successimg = plugin_dir_url(__FILE__)."images/success-image.png";
            $failedimg = plugin_dir_url(__FILE__)."images/failed-image.png";
            $content = '<div style="text-align: center;position: relative;">
            <img src="'.$l.'" alt="Moov Money" style="width: 100px;">
            </div>';
            echo "<center style='box-shadow:1px 1px 5px 1px #ccc;padding-bottom:5vh;' id='wc_mm_ga_order_status'><img src=".$g." id='wc_mm_loadergif' alt='Loading' style='width: 40px;'>";
            echo '<p style="font-weight:600;">'.$GLOBALS['wc_mc_gabon']->settings["loader"].'<span> </span></p>';
            echo $content;
            echo '</center>';
            echo "
            <script>
            function fetchStatus()
            {
                jQuery.ajax({
                    url : '".site_url()."/wp-admin/admin-ajax.php?action=fetch_order_status&order_id=$order',
                    type : 'post',      
                    error : function(response){
                        console.log(response);
                    },
                    success : function( response ){
                        console.log(response);
                        if (response === 'processing' || response === 'completed'){
                            let successImage = jQuery('<div><img id=\"moov_payment_success\" style=\"width:100px;padding:5vh;\" src = \"".$successimg."\" /><h5 >Paiement effectué avec Succès</h5></div>');
                            jQuery('#wc_mm_ga_order_status').html(successImage);
                            clearInterval(handleInterval);
                            clearTimeout(handleTimeout);
                        } else if (response === 'cancelled' || response === 'failed') {
                            let failedImage = jQuery('<div><img id=\"moov_payment_success\" style=\"width:100px;padding:5vh;\" src = \"".$failedimg."\" /><h5 >Paiement échoué</h5></div>');
                            jQuery('#wc_mm_ga_order_status').html(failedImage);
                            clearInterval(handleInterval);
                            clearTimeout(handleTimeout);
                        }
                    }
                });
            }

            function refreshStatus()
            {
                jQuery.ajax({
                    url : '".site_url()."/wp-admin/admin-ajax.php?action=refresh_order_status&order_id=$order',
                    type : 'post',      
                    error : function(response){
                        console.log(response);
                    },
                    success : function( response ){
                        console.log(response);
                        if (response === 'processing' || response === 'completed'){
                            let successImage = jQuery('<div><img id=\"moov_payment_success\" style=\"width:100px;padding:5vh;\" src = \"".$successimg."\" /><h5 >Paiement effectué avec Succès</h5></div>');
                            jQuery('#wc_mm_ga_order_status').html(successImage);
                            clearTimeout(handleTimeout);
                        } else if (response === 'cancelled' || response === 'failed') {
                            let failedImage = jQuery('<div><img id=\"moov_payment_success\" style=\"width:100px;padding:5vh;\" src = \"".$failedimg."\" /><h5 >Timeout : Paiement échoué </h5> <div><button style=\"background:black;padding:1rem 2rem;color:white;font-size:1rem;font-weight:300;border-radius:5px;border:none;\" onclick=\"runRefresh()\"><span id=\"wc_mm_refresh_loader1\"></span>Raffraichir le statut</button></div></div>');
                            jQuery('#wc_mm_ga_order_status').html(failedImage);
                            clearTimeout(handleTimeout);
                        } 
                        //jQuery(\"#wc_mm_refresh_loader1\").html('');
                    }
                });
            }

            function runRefresh(){
                jQuery(\"#wc_mm_refresh_loader1\").html('<img style=\"width:30px;top: 6px;position: relative;\" src=\"".$loaderWhite."\">');
                refreshStatus();
            }
            //Verification du statut chaque 10 secondes
            let handleInterval = setInterval(fetchStatus, 10000);
            //STOPER L'ATTENTE APRES 2 MINUTES
            const timeLimit = 10000;
            let handleTimeout = setInterval(() => {
                clearInterval(handleInterval);
                refreshStatus();
                handleInterval = false;
            },timeLimit);
            </script>
            ";
        }
        
    }
    
    /*
        on-hold ===  en attente
        processing === en cours 
        pending === en attente de paiement
        completed === terminee
        cancelled ==== annulee
        refunded === remboursee
        failed === echouee
        checkout-draft === brouillon 
    */
    function fetch_order_status(){
        $order = wc_get_order( $_REQUEST['order_id'] );
        $order_data = $order->get_data();
        echo $order_data['status'];
        die();
    }
    
    add_action('wp_ajax_nopriv_fetch_order_status', 'fetch_order_status');
    add_action('wp_ajax_fetch_order_status','fetch_order_status');
       
    function refresh_order_status(){
        $status = $GLOBALS['wc_mc_gabon']->chechPvitStatus($_REQUEST['order_id']);
        echo $status;
        die();
    }
    add_action('wp_ajax_nopriv_refresh_order_status', 'refresh_order_status');
    add_action('wp_ajax_refresh_order_status','refresh_order_status');
      
        
